/*
!xMeter.mq4     
Copyright  2007, MetaQuotes Software Corp.     
Price Meter System GPL     

Robert Hill
   5/16/2007 Corrected problem with IBFX mini Account

*/
/*
Number of currency pairs:  14

Currency pairs analyzed for trading:   
EURUSD, 
AUDJPY, 
AUDUSD,  
USDJPY, 
EURJPY,  
CHFJPY, 
NZDUSD, 
GBPUSD, 
EURGBP, 
EURCAD, 
USDCHF, 
GBPCHF 
GBPJPY


*/

#property copyright "x Meter System GPL"
#property link      "forex-tsd dot com"

#define ARRSIZE  7                     // number of pairs !!!DON'T CHANGE THIS NUMBER!!!
#define PAIRSIZE 7                      // number of currencies !!!DON'T CHANGE THIS NUMBER!!!
#define TABSIZE  10                     // scale of currency's power !!!DON'T CHANGE THIS NUMBER!!!
#define ORDER    2                      // available type of order !!!DON'T CHANGE THIS NUMBER!!!

// Added to make code easier to understand

// Currency
#define USD 0
#define EUR 1
#define GBP 2
#define CHF 3
#define CAD 4
#define AUD 5
#define JPY 6

//extern bool AccountIsIBFXmini = false;

   string aPair[ARRSIZE]   = {"USD","EUR","GBP","CHF","CAD","AUD","JPY"};
   //string aMajor[PAIRSIZE] = {"USD","EUR","GBP","CHF","CAD","AUD","JPY"};
  // string aOrder[ORDER]    = {"BUY ","SELL "};
//---- Trade parameters
extern string    Trade_parameters    = "=== Trade parameters ===";
extern double    Lot                 =            0.1;  // Lot size
extern int       Slippage            =            2;  // Slippage

//---- Lot size management
extern string    Lot_size_management = "=== Lot size management ===";
extern bool      ManagedLotSize      =         false;  // If true, lot size based on the free margin
extern double    Risk                =          2.0;  // Risk to protect the equity
extern int       MaxLot              =         10.0;  // Maximum lot size
//---- Number of pairs to trade
extern string    Pairs_To_Trade      = "=== How many pairs to trade? ===";
extern double    PairsToTrade        =          12.0;
//---- Pairs Selection
extern string    Trade_EUR_USD       = "=== Do you want to trade EURUSD? ===";
extern bool      EUR_USD             =         true;
extern double    HighLevel_EURUSD    =          7.0;  // Level to reach for 1st condition become true
extern double    LowLevel_EURUSD     =          2.0;  // Level to not exceed for 2nd condition become true
extern double    TakeProfit_EURUSD   =         10.0;  // Profit for the order opened
extern double    StopLoss_EURUSD     =         20.0;  // StopLoss
extern int       MaxSpread_EURUSD    =         10.0;

extern string    Trade_GBP_USD       = "=== Do you want to trade GBPUSD? ===";
extern bool      GBP_USD             =         true;
extern double    HighLevel_GBPUSD    =          7.0;  // Level to reach for 1st condition become true
extern double    LowLevel_GBPUSD     =          2.0;  // Level to not exceed for 2nd condition become true
extern double    TakeProfit_GBPUSD   =         10.0;  // Profit for the order opened
extern double    StopLoss_GBPUSD     =         20.0;  // StopLoss
extern int       MaxSpread_GBPUSD    =         10.0;

extern string    Trade_AUD_USD       = "=== Do you want to trade AUDUSD? ===";
extern bool      AUD_USD             =         true;
extern double    HighLevel_AUDUSD    =          7.0;  // Level to reach for 1st condition become true
extern double    LowLevel_AUDUSD     =          2.0;  // Level to not exceed for 2nd condition become true
extern double    TakeProfit_AUDUSD   =         10.0;  // Profit for the order opened
extern double    StopLoss_AUDUSD     =         20.0;  // StopLoss
extern int       MaxSpread_AUDUSD    =         10.0;

extern string    Trade_USD_JPY       = "=== Do you want to trade USDJPY? ===";
extern bool      USD_JPY             =         true;
extern double    HighLevel_USDJPY    =          7.0;  // Level to reach for 1st condition become true
extern double    LowLevel_USDJPY     =          2.0;  // Level to not exceed for 2nd condition become true
extern double    TakeProfit_USDJPY   =         10.0;  // Profit for the order opened
extern double    StopLoss_USDJPY     =         20.0;  // StopLoss
extern int       MaxSpread_USDJPY    =         10.0;

extern string    Trade_USD_CHF       = "=== Do you want to trade USDCHF? ===";
extern bool      USD_CHF             =          true;
extern double    HighLevel_USDCHF    =          7.0;  // Level to reach for 1st condition become true
extern double    LowLevel_USDCHF     =          2.0;  // Level to not exceed for 2nd condition become true
extern double    TakeProfit_USDCHF   =         10.0;  // Profit for the order opened
extern double    StopLoss_USDCHF     =         20.0;  // StopLoss
extern int       MaxSpread_USDCHF    =         10.0;

extern string    Trade_USD_CAD       = "=== Do you want to trade USDCAD? ===";
extern bool      USD_CAD             =          true;
extern double    HighLevel_USDCAD    =          7.0;  // Level to reach for 1st condition become true
extern double    LowLevel_USDCAD     =          2.0;  // Level to not exceed for 2nd condition become true
extern double    TakeProfit_USDCAD   =         10.0;  // Profit for the order opened
extern double    StopLoss_USDCAD     =         20.0;  // StopLoss
extern int       MaxSpread_USDCAD    =         10.0;

extern string    Trade_EUR_JPY       = "=== Do you want to trade EURJPY? ===";
extern bool      EUR_JPY             =         true;
extern double    HighLevel_EURJPY    =          7.0;  // Level to reach for 1st condition become true
extern double    LowLevel_EURJPY     =          2.0;  // Level to not exceed for 2nd condition become true
extern double    TakeProfit_EURJPY   =         10.0;  // Profit for the order opened
extern double    StopLoss_EURJPY     =         20.0;  // StopLoss
extern int       MaxSpread_EURJPY    =         10.0;

extern string    Trade_EUR_GBP       = "=== Do you want to trade EURGBP? ===";
extern bool      EUR_GBP             =         true;
extern double    HighLevel_EURGBP    =          7.0;  // Level to reach for 1st condition become true
extern double    LowLevel_EURGBP     =          2.0;  // Level to not exceed for 2nd condition become true
extern double    TakeProfit_EURGBP   =         10.0;  // Profit for the order opened
extern double    StopLoss_EURGBP     =         20.0;  // StopLoss
extern int       MaxSpread_EURGBP    =         10.0;

extern string    Trade_EUR_CHF       = "=== Do you want to trade EURCHF? ===";
extern bool      EUR_CHF             =         true;
extern double    HighLevel_EURCHF    =          7.0;  // Level to reach for 1st condition become true
extern double    LowLevel_EURCHF     =          2.0;  // Level to not exceed for 2nd condition become true
extern double    TakeProfit_EURCHF   =         10.0;  // Profit for the order opened
extern double    StopLoss_EURCHF     =         20.0;  // StopLoss
extern int       MaxSpread_EURCHF    =         10.0;

extern string    Trade_EUR_AUD       = "=== Do you want to trade EURAUD? ===";
extern bool      EUR_AUD             =         true;
extern double    HighLevel_EURAUD    =          7.0;  // Level to reach for 1st condition become true
extern double    LowLevel_EURAUD     =          2.0;  // Level to not exceed for 2nd condition become true
extern double    TakeProfit_EURAUD   =         10.0;  // Profit for the order opened
extern double    StopLoss_EURAUD     =         20.0;  // StopLoss
extern int       MaxSpread_EURAUD    =         10.0;

extern string    Trade_GBP_JPY       = "=== Do you want to trade GBPJPY? ===";
extern bool      GBP_JPY             =         true;
extern double    HighLevel_GBPJPY    =          7.0;  // Level to reach for 1st condition become true
extern double    LowLevel_GBPJPY     =          2.0;  // Level to not exceed for 2nd condition become true
extern double    TakeProfit_GBPJPY   =         10.0;  // Profit for the order opened
extern double    StopLoss_GBPJPY     =         20.0;  // StopLoss
extern int       MaxSpread_GBPJPY    =         10.0;

extern string    Trade_GBP_CHF       = "=== Do you want to trade GBPCHF? ===";
extern bool      GBP_CHF             =         true;
extern double    HighLevel_GBPCHF    =          7.0;  // Level to reach for 1st condition become true
extern double    LowLevel_GBPCHF     =          2.0;  // Level to not exceed for 2nd condition become true
extern double    TakeProfit_GBPCHF   =         10.0;  // Profit for the order opened
extern double    StopLoss_GBPCHF     =         20.0;  // StopLoss
extern int       MaxSpread_GBPCHF    =         10.0;
   
extern int n=7; //  
extern int Fmin=2;//2; //    .
extern int Fmax=128; //    .
extern bool volume = false;
int N;
double aa_USD[];
double aa_EUR[];
double aa_GBP[];
double aa_CHF[];
double aa_CAD[];
double aa_AUD[];
double aa_JPY[];

double aa_USD_tr[];
double aa_EUR_tr[];
double aa_GBP_tr[];
double aa_CHF_tr[];
double aa_CAD_tr[];
double aa_AUD_tr[];
double aa_JPY_tr[];

double vaa_USD[];
double vaa_EUR[];
double vaa_GBP[];
double vaa_CHF[];
double vaa_CAD[];
double vaa_AUD[];
double vaa_JPY[];

double vaa_USD_tr[];
double vaa_EUR_tr[];
double vaa_GBP_tr[];
double vaa_CHF_tr[];
double vaa_CAD_tr[];
double vaa_AUD_tr[];
double vaa_JPY_tr[];

double aMeter[PAIRSIZE];
double aHigh[ARRSIZE];
double aLow[ARRSIZE];
double aBid[ARRSIZE];
//double aAsk[ARRSIZE];
double aRatio[ARRSIZE];
double aRange[ARRSIZE];
//double aLookup[ARRSIZE];
double aStrength[ARRSIZE];

double vaMeter[PAIRSIZE];
double vaHigh[ARRSIZE];
double vaLow[ARRSIZE];
double vaBid[ARRSIZE];
//double vaAsk[ARRSIZE];
double vaRatio[ARRSIZE];
double vaRange[ARRSIZE];
//double vaLookup[ARRSIZE];
double vaStrength[ARRSIZE];

string trUSD,trEUR,trGBP,trCHF,trCAD,trAUD,trJPY;
string vtrUSD,vtrEUR,vtrGBP,vtrCHF,vtrCAD,vtrAUD,vtrJPY;
double trUSD1,trEUR1,trGBP1,trCHF1,trCAD1,trAUD1,trJPY1;
double vtrUSD1,vtrEUR1,vtrGBP1,vtrCHF1,vtrCAD1,vtrAUD1,vtrJPY1;

double   sl, tp, lot;
int      cnt, ticket, total;
int      MagicAUDCAD, MagicAUDJPY, MagicAUDNZD, MagicAUDUSD, MagicCHFJPY, MagicEURAUD, MagicEURCAD;
int      MagicEURCHF, MagicEURGBP, MagicEURJPY, MagicEURUSD, MagicGBPCHF, MagicGBPJPY, MagicGBPUSD;
int      MagicNZDJPY, MagicNZDUSD, MagicUSDCHF, MagicUSDJPY, MagicUSDCAD;
bool firstStart = true;  

//+------------------------------------------------------------------+
//     expert initialization function                                |       
//+------------------------------------------------------------------+
int initVars()
{
   int i;
   N=MathPow(2,n);
   ArrayResize(aa_USD,N);
   ArrayResize(aa_EUR,N);
   ArrayResize(aa_GBP,N);
   ArrayResize(aa_CHF,N);
   ArrayResize(aa_CAD,N);
   ArrayResize(aa_AUD,N);
   ArrayResize(aa_JPY,N);

   ArrayResize(aa_USD_tr,N-1);
   ArrayResize(aa_EUR_tr,N-1);
   ArrayResize(aa_GBP_tr,N-1);
   ArrayResize(aa_CHF_tr,N-1);
   ArrayResize(aa_CAD_tr,N-1);
   ArrayResize(aa_AUD_tr,N-1);
   ArrayResize(aa_JPY_tr,N-1);
   
   ArrayResize(vaa_USD,N);
   ArrayResize(vaa_EUR,N);
   ArrayResize(vaa_GBP,N);
   ArrayResize(vaa_CHF,N);
   ArrayResize(vaa_CAD,N);
   ArrayResize(vaa_AUD,N);
   ArrayResize(vaa_JPY,N);

   ArrayResize(vaa_USD_tr,N-1);
   ArrayResize(vaa_EUR_tr,N-1);
   ArrayResize(vaa_GBP_tr,N-1);
   ArrayResize(vaa_CHF_tr,N-1);
   ArrayResize(vaa_CAD_tr,N-1);
   ArrayResize(vaa_AUD_tr,N-1);
   ArrayResize(vaa_JPY_tr,N-1);


   trUSD="";
   trEUR="";
   trGBP="";
   trCHF="";
   trCAD="";
   trAUD="";
   trJPY="";

   vtrUSD="";
   vtrEUR="";
   vtrGBP="";
   vtrCHF="";
   vtrCAD="";
   vtrAUD="";
   vtrJPY="";


   RefreshRates();
   for( i=0; i<=N-1; i++) 
   { 
      aa_USD[i]=iCustom(Symbol(),0,"#_i_FFT_separate_Basket10_USD",n,Fmin,Fmax,0,i);
      aa_EUR[i]=iCustom(Symbol(),0,"#_i_FFT_separate_Basket10_EUR",n,Fmin,Fmax,0,i);
      aa_GBP[i]=iCustom(Symbol(),0,"#_i_FFT_separate_Basket10_GBP",n,Fmin,Fmax,0,i);
      aa_CHF[i]=iCustom(Symbol(),0,"#_i_FFT_separate_Basket10_CHF",n,Fmin,Fmax,0,i);
      aa_CAD[i]=iCustom(Symbol(),0,"#_i_FFT_separate_Basket10_CAD",n,Fmin,Fmax,0,i);
      aa_AUD[i]=iCustom(Symbol(),0,"#_i_FFT_separate_Basket10_AUD",n,Fmin,Fmax,0,i);
      aa_JPY[i]=iCustom(Symbol(),0,"#_i_FFT_separate_Basket10_JPY",n,Fmin,Fmax,0,i);

      vaa_USD[i]=iCustom(Symbol(),0,"#_i_FFT_separate_Basket10_USD_vol",n,Fmin,Fmax,0,i);
      vaa_EUR[i]=iCustom(Symbol(),0,"#_i_FFT_separate_Basket10_EUR_vol",n,Fmin,Fmax,0,i);
      vaa_GBP[i]=iCustom(Symbol(),0,"#_i_FFT_separate_Basket10_GBP_vol",n,Fmin,Fmax,0,i);
      vaa_CHF[i]=iCustom(Symbol(),0,"#_i_FFT_separate_Basket10_CHF_vol",n,Fmin,Fmax,0,i);
      vaa_CAD[i]=iCustom(Symbol(),0,"#_i_FFT_separate_Basket10_CAD_vol",n,Fmin,Fmax,0,i);
      vaa_AUD[i]=iCustom(Symbol(),0,"#_i_FFT_separate_Basket10_AUD_vol",n,Fmin,Fmax,0,i);
      vaa_JPY[i]=iCustom(Symbol(),0,"#_i_FFT_separate_Basket10_JPY_vol",n,Fmin,Fmax,0,i);

   }   
   int j;
   for( i=0,j=0; j<=N-2; i++,j++) 
   { 
      aa_USD_tr[j]=MathAbs(aa_USD[i]-aa_USD[i+1])*10000;
      aa_EUR_tr[j]=MathAbs(aa_EUR[i]-aa_EUR[i+1])*10000;
      aa_GBP_tr[j]=MathAbs(aa_GBP[i]-aa_GBP[i+1])*10000;
      aa_CHF_tr[j]=MathAbs(aa_CHF[i]-aa_CHF[i+1])*10000;
      aa_CAD_tr[j]=MathAbs(aa_CAD[i]-aa_CAD[i+1])*10000;
      aa_AUD_tr[j]=MathAbs(aa_AUD[i]-aa_AUD[i+1])*10000;
      aa_JPY_tr[j]=MathAbs(aa_JPY[i]-aa_JPY[i+1])*10000;

      vaa_USD_tr[j]=MathAbs(vaa_USD[i]-vaa_USD[i+1])*10;
      vaa_EUR_tr[j]=MathAbs(vaa_EUR[i]-vaa_EUR[i+1])*10;
      vaa_GBP_tr[j]=MathAbs(vaa_GBP[i]-vaa_GBP[i+1])*10;
      vaa_CHF_tr[j]=MathAbs(vaa_CHF[i]-vaa_CHF[i+1])*10;
      vaa_CAD_tr[j]=MathAbs(vaa_CAD[i]-vaa_CAD[i+1])*10;
      vaa_AUD_tr[j]=MathAbs(vaa_AUD[i]-vaa_AUD[i+1])*10;
      vaa_JPY_tr[j]=MathAbs(vaa_JPY[i]-vaa_JPY[i+1])*10;

   
   }   
   if(aa_USD[0]>aa_USD[1])
     trUSD="UP";
   else  
     trUSD="DOWN";

   if(aa_EUR[0]>aa_EUR[1])
     trEUR="UP";
   else  
     trEUR="DOWN";

   if(aa_GBP[0]>aa_GBP[1])
     trGBP="UP";
   else  
     trGBP="DOWN";

   if(aa_CHF[0]>aa_CHF[1])
     trCHF="UP";
   else  
     trCHF="DOWN";

   if(aa_CAD[0]>aa_CAD[1])
     trCAD="UP";
   else  
     trCAD="DOWN";

   if(aa_AUD[0]>aa_AUD[1])
     trAUD="UP";
   else  
     trAUD="DOWN";

   if(aa_JPY[0]>aa_JPY[1])
     trJPY="UP";
   else  
     trJPY="DOWN";
  
   //-----------------
   if(vaa_USD[0]>vaa_USD[1])
     vtrUSD="UP";
   else  
     vtrUSD="DOWN";

   if(vaa_EUR[0]>vaa_EUR[1])
     vtrEUR="UP";
   else  
     vtrEUR="DOWN";

   if(vaa_GBP[0]>vaa_GBP[1])
     vtrGBP="UP";
   else  
     vtrGBP="DOWN";

   if(vaa_CHF[0]>vaa_CHF[1])
     vtrCHF="UP";
   else  
     vtrCHF="DOWN";

   if(vaa_CAD[0]>vaa_CAD[1])
     vtrCAD="UP";
   else  
     vtrCAD="DOWN";

   if(vaa_AUD[0]>vaa_AUD[1])
     vtrAUD="UP";
   else  
     vtrAUD="DOWN";

   if(vaa_JPY[0]>vaa_JPY[1])
     vtrJPY="UP";
   else  
     vtrJPY="DOWN";


   trUSD1=GetItem_tr("USD", 0);//MathAbs(aa_USD[0]-aa_USD[1])*10000;
   trEUR1=GetItem_tr("EUR", 0);//MathAbs(aa_EUR[0]-aa_EUR[1])*10000;
   trGBP1=GetItem_tr("GBP", 0);//MathAbs(aa_GBP[0]-aa_GBP[1])*10000;
   trCHF1=GetItem_tr("CHF", 0);//MathAbs(aa_CHF[0]-aa_CHF[1])*10000;
   trCAD1=GetItem_tr("CAD", 0);//MathAbs(aa_CAD[0]-aa_CAD[1])*10000;
   trAUD1=GetItem_tr("AUD", 0);//MathAbs(aa_AUD[0]-aa_AUD[1])*10000;
   trJPY1=GetItem_tr("JPY", 0);//MathAbs(aa_JPY[0]-aa_JPY[1])*10000;     

   vtrUSD1=vGetItem_tr("USD", 0);//MathAbs(vaa_USD[0]-vaa_USD[1])*10;
   vtrEUR1=vGetItem_tr("EUR", 0);//MathAbs(vaa_EUR[0]-vaa_EUR[1])*10;
   vtrGBP1=vGetItem_tr("GBP", 0);//MathAbs(vaa_GBP[0]-vaa_GBP[1])*10;
   vtrCHF1=vGetItem_tr("CHF", 0);//MathAbs(vaa_CHF[0]-vaa_CHF[1])*10;
   vtrCAD1=vGetItem_tr("CAD", 0);//MathAbs(vaa_CAD[0]-vaa_CAD[1])*10;
   vtrAUD1=vGetItem_tr("AUD", 0);//MathAbs(vaa_AUD[0]-vaa_AUD[1])*10;
   vtrJPY1=vGetItem_tr("JPY", 0);//MathAbs(vaa_JPY[0]-vaa_JPY[1])*10;     

     
   //Comment("");
   string s1=""+
            
             " USD max:"+aa_USD[ArrayMaximum(aa_USD,WHOLE_ARRAY,0)]+
             " USD min:"+aa_USD[ArrayMinimum(aa_USD,WHOLE_ARRAY,0)]+
             " USD_tr max:"+aa_USD_tr[ArrayMaximum(aa_USD_tr,WHOLE_ARRAY,0)]+
             " USD_tr min:"+aa_USD_tr[ArrayMinimum(aa_USD_tr,WHOLE_ARRAY,0)]+

             " USD0:"+aa_USD[0]+
             " USD1:"+aa_USD[1]+
             " USD-> "+trUSD+"("+trUSD1+")"+

             "\n"+

             " EUR max:"+aa_EUR[ArrayMaximum(aa_EUR,WHOLE_ARRAY,0)]+
             " EUR min:"+aa_EUR[ArrayMinimum(aa_EUR,WHOLE_ARRAY,0)]+
             " EUR_tr max:"+aa_EUR_tr[ArrayMaximum(aa_EUR_tr,WHOLE_ARRAY,0)]+
             " EUR_tr min:"+aa_EUR_tr[ArrayMinimum(aa_EUR_tr,WHOLE_ARRAY,0)]+

             " EUR0:"+aa_EUR[0]+
             " EUR1:"+aa_EUR[1]+
             " EUR-> "+trEUR+"("+trEUR1+")"+

             "\n"+

             " GBP max:"+aa_GBP[ArrayMaximum(aa_GBP,WHOLE_ARRAY,0)]+
             " GBP min:"+aa_GBP[ArrayMinimum(aa_GBP,WHOLE_ARRAY,0)]+
             " GBP_tr max:"+aa_GBP_tr[ArrayMaximum(aa_GBP_tr,WHOLE_ARRAY,0)]+
             " GBP_tr min:"+aa_GBP_tr[ArrayMinimum(aa_GBP_tr,WHOLE_ARRAY,0)]+

             " GBP0:"+aa_GBP[0]+
             " GBP1:"+aa_GBP[1]+
             " GBP-> "+trGBP+"("+trGBP1+")"+

             "\n"+

             " CHF max:"+aa_CHF[ArrayMaximum(aa_CHF,WHOLE_ARRAY,0)]+
             " CHF min:"+aa_CHF[ArrayMinimum(aa_CHF,WHOLE_ARRAY,0)]+
             " CHF_tr max:"+aa_CHF_tr[ArrayMaximum(aa_CHF_tr,WHOLE_ARRAY,0)]+
             " CHF_tr min:"+aa_CHF_tr[ArrayMinimum(aa_CHF_tr,WHOLE_ARRAY,0)]+

             " CHF0:"+aa_CHF[0]+
             " CHF1:"+aa_CHF[1]+
             " CHF-> "+trCHF+"("+trCHF1+")"+

             "\n"+

             " CAD max:"+aa_CAD[ArrayMaximum(aa_CAD,WHOLE_ARRAY,0)]+
             " CAD min:"+aa_CAD[ArrayMinimum(aa_CAD,WHOLE_ARRAY,0)]+
             " CAD_tr max:"+aa_CAD_tr[ArrayMaximum(aa_CAD_tr,WHOLE_ARRAY,0)]+
             " CAD_tr min:"+aa_CAD_tr[ArrayMinimum(aa_CAD_tr,WHOLE_ARRAY,0)]+

             " CAD0:"+aa_CAD[0]+
             " CAD1:"+aa_CAD[1]+
             " CAD-> "+trCAD+"("+trCAD1+")"+

             "\n"+

             " AUD max:"+aa_AUD[ArrayMaximum(aa_AUD,WHOLE_ARRAY,0)]+
             " AUD min:"+aa_AUD[ArrayMinimum(aa_AUD,WHOLE_ARRAY,0)]+
             " AUD_tr max:"+aa_AUD_tr[ArrayMaximum(aa_AUD_tr,WHOLE_ARRAY,0)]+
             " AUD_tr min:"+aa_AUD_tr[ArrayMinimum(aa_AUD_tr,WHOLE_ARRAY,0)]+

             " AUD0:"+aa_AUD[0]+
             " AUD1:"+aa_AUD[1]+
             " AUD-> "+trAUD+"("+trAUD1+")"+

             "\n"+

             " JPY max:"+aa_JPY[ArrayMaximum(aa_JPY,WHOLE_ARRAY,0)]+
             " JPY min:"+aa_JPY[ArrayMinimum(aa_JPY,WHOLE_ARRAY,0)]+
             " JPY_tr max:"+aa_JPY_tr[ArrayMaximum(aa_JPY_tr,WHOLE_ARRAY,0)]+
             " JPY_tr min:"+aa_JPY_tr[ArrayMinimum(aa_JPY_tr,WHOLE_ARRAY,0)]+

             " JPY0:"+aa_JPY[0]+
             " JPY1:"+aa_JPY[1]+
             " JPY-> "+trJPY+"("+trJPY1+")";


   string s2=""+
            
             " vUSD max:"+vaa_USD[ArrayMaximum(vaa_USD,WHOLE_ARRAY,0)]+
             " vUSD min:"+vaa_USD[ArrayMinimum(vaa_USD,WHOLE_ARRAY,0)]+
             " vUSD_tr max:"+vaa_USD_tr[ArrayMaximum(vaa_USD_tr,WHOLE_ARRAY,0)]+
             " vUSD_tr min:"+vaa_USD_tr[ArrayMinimum(vaa_USD_tr,WHOLE_ARRAY,0)]+
             " vUSD0:"+vaa_USD[0]+
             " vUSD1:"+vaa_USD[1]+
             " vUSD-> "+vtrUSD+"("+vtrUSD1+")"+

             "\n"+

             " vEUR max:"+vaa_EUR[ArrayMaximum(vaa_EUR,WHOLE_ARRAY,0)]+
             " vEUR min:"+vaa_EUR[ArrayMinimum(vaa_EUR,WHOLE_ARRAY,0)]+
             " vEUR_tr max:"+vaa_EUR_tr[ArrayMaximum(vaa_EUR_tr,WHOLE_ARRAY,0)]+
             " vEUR_tr min:"+vaa_EUR_tr[ArrayMinimum(vaa_EUR_tr,WHOLE_ARRAY,0)]+
             " vEUR0:"+vaa_EUR[0]+
             " vEUR1:"+vaa_EUR[1]+
             " vEUR-> "+vtrEUR+"("+vtrEUR1+")"+
             "\n"+

             " vGBP max:"+vaa_GBP[ArrayMaximum(vaa_GBP,WHOLE_ARRAY,0)]+
             " vGBP min:"+vaa_GBP[ArrayMinimum(vaa_GBP,WHOLE_ARRAY,0)]+
             " vGBP_tr max:"+vaa_GBP_tr[ArrayMaximum(vaa_GBP_tr,WHOLE_ARRAY,0)]+
             " vGBP_tr min:"+vaa_GBP_tr[ArrayMinimum(vaa_GBP_tr,WHOLE_ARRAY,0)]+
             " vGBP0:"+vaa_GBP[0]+
             " vGBP1:"+vaa_GBP[1]+
             " vGBP-> "+vtrGBP+"("+vtrGBP1+")"+
             "\n"+

             " vCHF max:"+vaa_CHF[ArrayMaximum(vaa_CHF,WHOLE_ARRAY,0)]+
             " vCHF min:"+vaa_CHF[ArrayMinimum(vaa_CHF,WHOLE_ARRAY,0)]+
             " vCHF_tr max:"+vaa_CHF_tr[ArrayMaximum(vaa_CHF_tr,WHOLE_ARRAY,0)]+
             " vCHF_tr min:"+vaa_CHF_tr[ArrayMinimum(vaa_CHF_tr,WHOLE_ARRAY,0)]+
             " vCHF0:"+vaa_CHF[0]+
             " vCHF1:"+vaa_CHF[1]+
             " vCHF-> "+vtrCHF+"("+vtrCHF1+")"+
             "\n"+

             " vCAD max:"+vaa_CAD[ArrayMaximum(vaa_CAD,WHOLE_ARRAY,0)]+
             " vCAD min:"+vaa_CAD[ArrayMinimum(vaa_CAD,WHOLE_ARRAY,0)]+
             " vCAD_tr max:"+vaa_CAD_tr[ArrayMaximum(vaa_CAD_tr,WHOLE_ARRAY,0)]+
             " vCAD_tr min:"+vaa_CAD_tr[ArrayMinimum(vaa_CAD_tr,WHOLE_ARRAY,0)]+
             " vCAD0:"+vaa_CAD[0]+
             " vCAD1:"+vaa_CAD[1]+
             " vCAD-> "+vtrCAD+"("+vtrCAD1+")"+
             "\n"+

             " vAUD max:"+vaa_AUD[ArrayMaximum(vaa_AUD,WHOLE_ARRAY,0)]+
             " vAUD min:"+vaa_AUD[ArrayMinimum(vaa_AUD,WHOLE_ARRAY,0)]+
             " vAUD_tr max:"+vaa_AUD_tr[ArrayMaximum(vaa_AUD_tr,WHOLE_ARRAY,0)]+
             " vAUD_tr min:"+vaa_AUD_tr[ArrayMinimum(vaa_AUD_tr,WHOLE_ARRAY,0)]+
             " vAUD0:"+vaa_AUD[0]+
             " vAUD1:"+vaa_AUD[1]+
             " vAUD-> "+vtrAUD+"("+vtrAUD1+")"+
             "\n"+

             " vJPY max:"+vaa_JPY[ArrayMaximum(vaa_JPY,WHOLE_ARRAY,0)]+
             " vJPY min:"+vaa_JPY[ArrayMinimum(vaa_JPY,WHOLE_ARRAY,0)]+
             " vJPY_tr max:"+vaa_JPY_tr[ArrayMaximum(vaa_JPY_tr,WHOLE_ARRAY,0)]+
             " vJPY_tr min:"+vaa_JPY_tr[ArrayMinimum(vaa_JPY_tr,WHOLE_ARRAY,0)]+
             " vJPY0:"+vaa_JPY[0]+
             " vJPY1:"+vaa_JPY[1]+
             " vJPY-> "+vtrJPY+"("+vtrJPY1+")";

             
             
             
   Comment("\n",s1,"\n\n",s2);
   
   
   if (Symbol() == "AUDCADm" || Symbol() == "AUDCAD") { MagicAUDCAD = 426801; }
   if (Symbol() == "AUDJPYm" || Symbol() == "AUDJPY") { MagicAUDJPY = 426802; }
   if (Symbol() == "AUDNZDm" || Symbol() == "AUDNZD") { MagicAUDNZD = 426803; }
   if (Symbol() == "AUDUSDm" || Symbol() == "AUDUSD") { MagicAUDUSD = 426804; }
   if (Symbol() == "CHFJPYm" || Symbol() == "CHFJPY") { MagicCHFJPY = 426805; }
   if (Symbol() == "EURAUDm" || Symbol() == "EURAUD") { MagicEURAUD = 426806; }
   if (Symbol() == "EURCADm" || Symbol() == "EURCAD") { MagicEURCAD = 426807; }
   if (Symbol() == "EURCHFm" || Symbol() == "EURCHF") { MagicEURCHF = 426808; }
   if (Symbol() == "EURGBPm" || Symbol() == "EURGBP") { MagicEURGBP = 426809; }
   if (Symbol() == "EURJPYm" || Symbol() == "EURJPY") { MagicEURJPY = 426810; }
   if (Symbol() == "EURUSDm" || Symbol() == "EURUSD") { MagicEURUSD = 426811; }
   if (Symbol() == "GBPCHFm" || Symbol() == "GBPCHF") { MagicGBPCHF = 426812; }
   if (Symbol() == "GBPJPYm" || Symbol() == "GBPJPY") { MagicGBPJPY = 426813; }
   if (Symbol() == "GBPUSDm" || Symbol() == "GBPUSD") { MagicGBPUSD = 426814; }
   if (Symbol() == "NZDJPYm" || Symbol() == "NZDJPY") { MagicNZDJPY = 426815; }
   if (Symbol() == "NZDUSDm" || Symbol() == "NZDUSD") { MagicNZDUSD = 426816; }
   if (Symbol() == "USDCHFm" || Symbol() == "USDCHF") { MagicUSDCHF = 426817; }
   if (Symbol() == "USDJPYm" || Symbol() == "USDJPY") { MagicUSDJPY = 426818; }
   if (Symbol() == "USDCADm" || Symbol() == "USDCAD") { MagicUSDCAD = 426819; }
}

double GetMax(string mySymbol)
{
  double max1;
   //if(StringFind(Symbol(),"m",0)>0)
  // {
  //   mySymbol = mySymbol+"m";
  // } 
 if (mySymbol=="USD")   
   max1=aa_USD[ArrayMaximum(aa_USD,WHOLE_ARRAY,0)];
 else if (mySymbol=="EUR")   
   max1=aa_EUR[ArrayMaximum(aa_EUR,WHOLE_ARRAY,0)];
 else if (mySymbol=="GBP")   
   max1=aa_GBP[ArrayMaximum(aa_GBP,WHOLE_ARRAY,0)];
 else if (mySymbol=="CHF")   
   max1=aa_CHF[ArrayMaximum(aa_CHF,WHOLE_ARRAY,0)];
 else if (mySymbol=="CAD")   
   max1=aa_CAD[ArrayMaximum(aa_CAD,WHOLE_ARRAY,0)];
 else if (mySymbol=="AUD")   
   max1=aa_AUD[ArrayMaximum(aa_AUD,WHOLE_ARRAY,0)];
 else if (mySymbol=="JPY")   
   max1=aa_JPY[ArrayMaximum(aa_JPY,WHOLE_ARRAY,0)];

  return(max1);

}


double GetMax_tr(string mySymbol)
{
  double max1;
   //if(StringFind(Symbol(),"m",0)>0)
  // {
  //   mySymbol = mySymbol+"m";
  // } 
 if (mySymbol=="USD")   
   max1=aa_USD_tr[ArrayMaximum(aa_USD_tr,WHOLE_ARRAY,0)];
 else if (mySymbol=="EUR")   
   max1=aa_EUR_tr[ArrayMaximum(aa_EUR_tr,WHOLE_ARRAY,0)];
 else if (mySymbol=="GBP")   
   max1=aa_GBP_tr[ArrayMaximum(aa_GBP_tr,WHOLE_ARRAY,0)];
 else if (mySymbol=="CHF")   
   max1=aa_CHF_tr[ArrayMaximum(aa_CHF_tr,WHOLE_ARRAY,0)];
 else if (mySymbol=="CAD")   
   max1=aa_CAD_tr[ArrayMaximum(aa_CAD_tr,WHOLE_ARRAY,0)];
 else if (mySymbol=="AUD")   
   max1=aa_AUD_tr[ArrayMaximum(aa_AUD_tr,WHOLE_ARRAY,0)];
 else if (mySymbol=="JPY")   
   max1=aa_JPY_tr[ArrayMaximum(aa_JPY_tr,WHOLE_ARRAY,0)];

  return(max1);

}


double vGetMax(string mySymbol)
{
  double max1;
   //if(StringFind(Symbol(),"m",0)>0)
  // {
  //   mySymbol = mySymbol+"m";
  // } 
 if (mySymbol=="USD")   
   max1=vaa_USD[ArrayMaximum(vaa_USD,WHOLE_ARRAY,0)];
 else if (mySymbol=="EUR")   
   max1=vaa_EUR[ArrayMaximum(vaa_EUR,WHOLE_ARRAY,0)];
 else if (mySymbol=="GBP")   
   max1=vaa_GBP[ArrayMaximum(vaa_GBP,WHOLE_ARRAY,0)];
 else if (mySymbol=="CHF")   
   max1=vaa_CHF[ArrayMaximum(vaa_CHF,WHOLE_ARRAY,0)];
 else if (mySymbol=="CAD")   
   max1=vaa_CAD[ArrayMaximum(vaa_CAD,WHOLE_ARRAY,0)];
 else if (mySymbol=="AUD")   
   max1=vaa_AUD[ArrayMaximum(vaa_AUD,WHOLE_ARRAY,0)];
 else if (mySymbol=="JPY")   
   max1=vaa_JPY[ArrayMaximum(vaa_JPY,WHOLE_ARRAY,0)];

  return(max1);

}

double vGetMax_tr(string mySymbol)
{
  double max1;
   //if(StringFind(Symbol(),"m",0)>0)
  // {
  //   mySymbol = mySymbol+"m";
  // } 
 if (mySymbol=="USD")   
   max1=vaa_USD_tr[ArrayMaximum(vaa_USD_tr,WHOLE_ARRAY,0)];
 else if (mySymbol=="EUR")   
   max1=vaa_EUR_tr[ArrayMaximum(vaa_EUR_tr,WHOLE_ARRAY,0)];
 else if (mySymbol=="GBP")   
   max1=vaa_GBP_tr[ArrayMaximum(vaa_GBP_tr,WHOLE_ARRAY,0)];
 else if (mySymbol=="CHF")   
   max1=vaa_CHF_tr[ArrayMaximum(vaa_CHF_tr,WHOLE_ARRAY,0)];
 else if (mySymbol=="CAD")   
   max1=vaa_CAD_tr[ArrayMaximum(vaa_CAD_tr,WHOLE_ARRAY,0)];
 else if (mySymbol=="AUD")   
   max1=vaa_AUD_tr[ArrayMaximum(vaa_AUD_tr,WHOLE_ARRAY,0)];
 else if (mySymbol=="JPY")   
   max1=vaa_JPY_tr[ArrayMaximum(vaa_JPY_tr,WHOLE_ARRAY,0)];

  return(max1);

}


double GetMin(string mySymbol)
{
  double min1;
   //if(StringFind(Symbol(),"m",0)>0)
  // {
  //   mySymbol = mySymbol+"m";
  // } 
 if (mySymbol=="USD")   
   min1=aa_USD[ArrayMinimum(aa_USD,WHOLE_ARRAY,0)];
 else if (mySymbol=="EUR")   
   min1=aa_EUR[ArrayMinimum(aa_EUR,WHOLE_ARRAY,0)];
 else if (mySymbol=="GBP")   
   min1=aa_GBP[ArrayMinimum(aa_GBP,WHOLE_ARRAY,0)];
 else if (mySymbol=="CHF")   
   min1=aa_CHF[ArrayMinimum(aa_CHF,WHOLE_ARRAY,0)];
 else if (mySymbol=="CAD")   
   min1=aa_CAD[ArrayMinimum(aa_CAD,WHOLE_ARRAY,0)];
 else if (mySymbol=="AUD")   
   min1=aa_AUD[ArrayMinimum(aa_AUD,WHOLE_ARRAY,0)];
 else if (mySymbol=="JPY")   
   min1=aa_JPY[ArrayMinimum(aa_JPY,WHOLE_ARRAY,0)];

  return(min1);

}


double GetMin_tr(string mySymbol)
{
  double min1;
   //if(StringFind(Symbol(),"m",0)>0)
  // {
  //   mySymbol = mySymbol+"m";
  // } 
 if (mySymbol=="USD")   
   min1=aa_USD_tr[ArrayMinimum(aa_USD_tr,WHOLE_ARRAY,0)];
 else if (mySymbol=="EUR")   
   min1=aa_EUR_tr[ArrayMinimum(aa_EUR_tr,WHOLE_ARRAY,0)];
 else if (mySymbol=="GBP")   
   min1=aa_GBP_tr[ArrayMinimum(aa_GBP_tr,WHOLE_ARRAY,0)];
 else if (mySymbol=="CHF")   
   min1=aa_CHF_tr[ArrayMinimum(aa_CHF_tr,WHOLE_ARRAY,0)];
 else if (mySymbol=="CAD")   
   min1=aa_CAD_tr[ArrayMinimum(aa_CAD_tr,WHOLE_ARRAY,0)];
 else if (mySymbol=="AUD")   
   min1=aa_AUD_tr[ArrayMinimum(aa_AUD_tr,WHOLE_ARRAY,0)];
 else if (mySymbol=="JPY")   
   min1=aa_JPY_tr[ArrayMinimum(aa_JPY_tr,WHOLE_ARRAY,0)];

  return(min1);

}


double vGetMin(string mySymbol)
{
  double min1;
   //if(StringFind(Symbol(),"m",0)>0)
  // {
  //   mySymbol = mySymbol+"m";
  // } 
 if (mySymbol=="USD")   
   min1=vaa_USD[ArrayMinimum(vaa_USD,WHOLE_ARRAY,0)];
 else if (mySymbol=="EUR")   
   min1=vaa_EUR[ArrayMinimum(vaa_EUR,WHOLE_ARRAY,0)];
 else if (mySymbol=="GBP")   
   min1=vaa_GBP[ArrayMinimum(vaa_GBP,WHOLE_ARRAY,0)];
 else if (mySymbol=="CHF")   
   min1=vaa_CHF[ArrayMinimum(vaa_CHF,WHOLE_ARRAY,0)];
 else if (mySymbol=="CAD")   
   min1=vaa_CAD[ArrayMinimum(vaa_CAD,WHOLE_ARRAY,0)];
 else if (mySymbol=="AUD")   
   min1=vaa_AUD[ArrayMinimum(vaa_AUD,WHOLE_ARRAY,0)];
 else if (mySymbol=="JPY")   
   min1=vaa_JPY[ArrayMinimum(vaa_JPY,WHOLE_ARRAY,0)];

  return(min1);

}

double vGetMin_tr(string mySymbol)
{
  double min1;
   //if(StringFind(Symbol(),"m",0)>0)
  // {
  //   mySymbol = mySymbol+"m";
  // } 
 if (mySymbol=="USD")   
   min1=vaa_USD_tr[ArrayMinimum(vaa_USD_tr,WHOLE_ARRAY,0)];
 else if (mySymbol=="EUR")   
   min1=vaa_EUR_tr[ArrayMinimum(vaa_EUR_tr,WHOLE_ARRAY,0)];
 else if (mySymbol=="GBP")   
   min1=vaa_GBP_tr[ArrayMinimum(vaa_GBP_tr,WHOLE_ARRAY,0)];
 else if (mySymbol=="CHF")   
   min1=vaa_CHF_tr[ArrayMinimum(vaa_CHF_tr,WHOLE_ARRAY,0)];
 else if (mySymbol=="CAD")   
   min1=vaa_CAD_tr[ArrayMinimum(vaa_CAD_tr,WHOLE_ARRAY,0)];
 else if (mySymbol=="AUD")   
   min1=vaa_AUD_tr[ArrayMinimum(vaa_AUD_tr,WHOLE_ARRAY,0)];
 else if (mySymbol=="JPY")   
   min1=vaa_JPY_tr[ArrayMinimum(vaa_JPY_tr,WHOLE_ARRAY,0)];

  return(min1);

}


double GetItem(string mySymbol, int Item)
{
  double x1;
   //if(StringFind(Symbol(),"m",0)>0)
  // {
  //   mySymbol = mySymbol+"m";
  // } 
 if(Item>N) Item=N; 
 if (mySymbol=="USD")   
   x1=aa_USD[Item];
 else if (mySymbol=="EUR")   
   x1=aa_EUR[Item];
 else if (mySymbol=="GBP")   
   x1=aa_GBP[Item];
 else if (mySymbol=="CHF")   
   x1=aa_CHF[Item];
 else if (mySymbol=="CAD")   
   x1=aa_CAD[Item];
 else if (mySymbol=="AUD")   
   x1=aa_AUD[Item];
 else if (mySymbol=="JPY")   
   x1=aa_JPY[Item];

  return(x1);

}

double GetItem_tr(string mySymbol, int Item)
{
  double x1;
   //if(StringFind(Symbol(),"m",0)>0)
  // {
  //   mySymbol = mySymbol+"m";
  // } 
 if(Item>N) Item=N; 
 if (mySymbol=="USD")   
   x1=aa_USD_tr[Item];
 else if (mySymbol=="EUR")   
   x1=aa_EUR_tr[Item];
 else if (mySymbol=="GBP")   
   x1=aa_GBP_tr[Item];
 else if (mySymbol=="CHF")   
   x1=aa_CHF_tr[Item];
 else if (mySymbol=="CAD")   
   x1=aa_CAD_tr[Item];
 else if (mySymbol=="AUD")   
   x1=aa_AUD_tr[Item];
 else if (mySymbol=="JPY")   
   x1=aa_JPY_tr[Item];

  return(x1);

}


double vGetItem(string mySymbol, int Item)
{
  double x1;
   //if(StringFind(Symbol(),"m",0)>0)
  // {
  //   mySymbol = mySymbol+"m";
  // } 
 if(Item>N) Item=N; 
 if (mySymbol=="USD")   
   x1=vaa_USD[Item];
 else if (mySymbol=="EUR")   
   x1=vaa_EUR[Item];
 else if (mySymbol=="GBP")   
   x1=vaa_GBP[Item];
 else if (mySymbol=="CHF")   
   x1=vaa_CHF[Item];
 else if (mySymbol=="CAD")   
   x1=vaa_CAD[Item];
 else if (mySymbol=="AUD")   
   x1=vaa_AUD[Item];
 else if (mySymbol=="JPY")   
   x1=vaa_JPY[Item];

  return(x1);

}

double vGetItem_tr(string mySymbol, int Item)
{
  double x1;
   //if(StringFind(Symbol(),"m",0)>0)
  // {
  //   mySymbol = mySymbol+"m";
  // } 
 if(Item>N) Item=N; 
 if (mySymbol=="USD")   
   x1=vaa_USD_tr[Item];
 else if (mySymbol=="EUR")   
   x1=vaa_EUR_tr[Item];
 else if (mySymbol=="GBP")   
   x1=vaa_GBP_tr[Item];
 else if (mySymbol=="CHF")   
   x1=vaa_CHF_tr[Item];
 else if (mySymbol=="CAD")   
   x1=vaa_CAD_tr[Item];
 else if (mySymbol=="AUD")   
   x1=vaa_AUD_tr[Item];
 else if (mySymbol=="JPY")   
   x1=vaa_JPY_tr[Item];

  return(x1);

}


int init()
  {
   int   err,lastError;
//----
   //initVars();
   initGraph();
   while (true)                                                             // infinite loop for main program
      {
      if (IsConnected()) main();
      if (!IsConnected()) objectBlank();
      WindowRedraw();
      Sleep(1000);                                                          // give your PC a breath
      }
//----
   return(0);                                                               // end of init function
  }
//+------------------------------------------------------------------+
//     expert deinitialization function                              |       
//+------------------------------------------------------------------+
int deinit()
  {
//----
   ObjectsDeleteAll(0,OBJ_LABEL);
   Print("shutdown error - ",GetLastError());                               // system is detached from platform
//----
   return(0);                                                               // end of deinit function
  }
//+------------------------------------------------------------------+
//     expert start function                                         |       
//+------------------------------------------------------------------+
int start()
  {
//----

//----
   return(0);                                                               // end of start funtion
  }
//+------------------------------------------------------------------+
//     expert custom function                                        |       
//+------------------------------------------------------------------+    
void main()                                                                 // this a control center
  {
//----

   int    index;
   string mySymbol;
   //~~~~~~~~~~~~~~
   initVars();  
   //~~~~~~~~~~~~
   for (index = 0; index < ARRSIZE; index++)                                // initialize all pairs required value 
   {
      mySymbol = aPair[index];

      aHigh[index]     = GetMax(mySymbol);//MarketInfo(mySymbol,MODE_HIGH);                // set a high today
      aLow[index]      = GetMin(mySymbol);//MarketInfo(mySymbol,MODE_LOW);                 // set a low today
      aBid[index]      = (GetItem(mySymbol,0));//+GetItem(mySymbol,1))/2;//MarketInfo(mySymbol,MODE_BID);                 // set a last bid
      aRange[index]    = MathAbs(aHigh[index]-aLow[index]);       // calculate range today      
      aRatio[index]    = MathAbs(aBid[index]-aLow[index])/aRange[index];     // calculate pair ratio
      aStrength[index]   = iLookup(aRatio[index]*100);                        // set a pair grade


      vaHigh[index]     = vGetMax(mySymbol);//MarketInfo(mySymbol,MODE_HIGH);                // set a high today
      vaLow[index]      = vGetMin(mySymbol);//MarketInfo(mySymbol,MODE_LOW);                 // set a low today
      vaBid[index]      = (vGetItem(mySymbol,0));//+GetItem(mySymbol,1))/2;//MarketInfo(mySymbol,MODE_BID);                 // set a last bid
      vaRange[index]    = MathAbs(vaHigh[index]-vaLow[index]);       // calculate range today      
      vaRatio[index]    = MathAbs(vaBid[index]-vaLow[index])/vaRange[index];     // calculate pair ratio
      vaStrength[index] = viLookup(vaRatio[index]*120);                        // set a pair grade
      

      string ss1=StringConcatenate("--->",index," range=>",aRange[index]," ratio=>",aRatio[index]," level=>",aBid[index]," strength=>",aStrength[index]);
      string ss2=StringConcatenate("  Vol---> vrange=>",vaRange[index]," vratio=>",vaRatio[index]," vlevel=>",vaBid[index]," vstrength=>",vaStrength[index]);
      Print(ss2);
   } 

   // calculate all currencies meter  
   if (volume==false)
   {       
     aMeter[USD] = NormalizeDouble((aStrength[USD]),1);
     aMeter[EUR] = NormalizeDouble((aStrength[EUR]),1);
     aMeter[GBP] = NormalizeDouble((aStrength[GBP]),1);
     aMeter[CHF] = NormalizeDouble((aStrength[CHF]),1);
     aMeter[CAD] = NormalizeDouble((aStrength[CAD]),1);
     aMeter[AUD] = NormalizeDouble((aStrength[AUD]),1);
     aMeter[JPY] = NormalizeDouble((aStrength[JPY]),1);     
   }
   else  
   {       
     aMeter[USD] = NormalizeDouble((vaStrength[USD]),1);
     aMeter[EUR] = NormalizeDouble((vaStrength[EUR]),1);
     aMeter[GBP] = NormalizeDouble((vaStrength[GBP]),1);
     aMeter[CHF] = NormalizeDouble((vaStrength[CHF]),1);
     aMeter[CAD] = NormalizeDouble((vaStrength[CAD]),1);
     aMeter[AUD] = NormalizeDouble((vaStrength[AUD]),1);
     aMeter[JPY] = NormalizeDouble((vaStrength[JPY]),1);     
   }

             
   objectBlank();   
   paintUSD(aMeter[USD]);
   paintEUR(aMeter[EUR]);
   paintGBP(aMeter[GBP]);
   paintCHF(aMeter[CHF]);
   paintCAD(aMeter[CAD]);
   paintAUD(aMeter[AUD]);
   paintJPY(aMeter[JPY]);
   paintLine();
                                                                            
//----

//---- Lot size calculation
 
    if ( ManagedLotSize )
    {
     lot = (( AccountBalance() * Risk ) / 1000) / PairsToTrade;
     if ( lot > MaxLot ) { lot = MaxLot; }
    }
    else { lot = Lot; }
    
//---- GO TRADING

   double eur = aMeter[EUR];
   double usd = aMeter[USD];
   double gbp = aMeter[GBP];
   double chf = aMeter[CHF];
   double cad = aMeter[CAD];
   double aud = aMeter[AUD];
   double jpy = aMeter[JPY]; 
   
    if ( EUR_USD == true && eur >= HighLevel_EURUSD && usd <= LowLevel_EURUSD && eur > 0 && usd > 0) { ManageBuy("EURUSDm",lot,TakeProfit_EURUSD,StopLoss_EURUSD,Slippage,MaxSpread_EURUSD,426811,"!xMeter EURvsUSD"); }
    if ( EUR_USD == true && usd >= HighLevel_EURUSD && eur <= LowLevel_EURUSD && eur > 0 && usd > 0) { ManageSell("EURUSDm",lot,TakeProfit_EURUSD,StopLoss_EURUSD,Slippage,MaxSpread_EURUSD,426811,"!xMeter EURvsUSD"); }
      
    if ( GBP_USD == true && gbp >= HighLevel_GBPUSD && usd <= LowLevel_GBPUSD && gbp > 0 && usd > 0) { ManageBuy("GBPUSDm",lot,TakeProfit_GBPUSD,StopLoss_GBPUSD,Slippage,MaxSpread_GBPUSD,426814,"!xMeter GBPvsUSD"); }
    if ( GBP_USD == true && usd >= HighLevel_GBPUSD && gbp <= LowLevel_GBPUSD && gbp > 0 && usd > 0) { ManageSell("GBPUSDm",lot,TakeProfit_GBPUSD,StopLoss_GBPUSD,Slippage,MaxSpread_GBPUSD,426814,"!xMeter GBPvsUSD"); }
   
    if ( AUD_USD == true && aud >= HighLevel_AUDUSD && usd <= LowLevel_AUDUSD && aud > 0 && usd > 0) { ManageBuy("AUDUSDm",lot,TakeProfit_AUDUSD,StopLoss_AUDUSD,Slippage,MaxSpread_AUDUSD,426804,"!xMeter AUDvsUSD"); }
    if ( AUD_USD == true && usd >= HighLevel_AUDUSD && aud <= LowLevel_AUDUSD && aud > 0 && usd > 0) { ManageSell("AUDUSDm",lot,TakeProfit_AUDUSD,StopLoss_AUDUSD,Slippage,MaxSpread_AUDUSD,426804,"!xMeter AUDvsUSD"); }
   
    if ( USD_JPY == true && usd >= HighLevel_USDJPY && jpy <= LowLevel_USDJPY && usd > 0 && jpy > 0) { ManageBuy("USDJPYm",lot,TakeProfit_USDJPY,StopLoss_USDJPY,Slippage,MaxSpread_USDJPY,426818,"!xMeter USDvsJPY"); }
    if ( USD_JPY == true && jpy >= HighLevel_USDJPY && usd <= LowLevel_USDJPY && usd > 0 && jpy > 0) { ManageSell("USDJPYm",lot,TakeProfit_USDJPY,StopLoss_USDJPY,Slippage,MaxSpread_USDJPY,426818,"!xMeter USDvsJPY"); }
   
    if ( USD_CHF == true && usd >= HighLevel_USDCHF && chf <= LowLevel_USDCHF && usd > 0 && chf > 0) { ManageBuy("USDCHFm",lot,TakeProfit_USDCHF,StopLoss_USDCHF,Slippage,MaxSpread_USDCHF,426817,"!xMeter USDvsCHF"); }
    if ( USD_CHF == true && chf >= HighLevel_USDCHF && usd <= LowLevel_USDCHF && usd > 0 && chf > 0) { ManageSell("USDCHFm",lot,TakeProfit_USDCHF,StopLoss_USDCHF,Slippage,MaxSpread_USDCHF,426817,"!xMeter USDvsCHF"); }
   
    if ( USD_CAD == true && usd >= HighLevel_USDCAD && cad <= LowLevel_USDCAD && usd > 0 && cad > 0) { ManageBuy("USDCADm",lot,TakeProfit_USDCAD,StopLoss_USDCAD,Slippage,MaxSpread_USDCAD,426819,"!xMeter USDvsCAD"); }
    if ( USD_CAD == true && cad >= HighLevel_USDCAD && usd <= LowLevel_USDCAD && usd > 0 && cad > 0) { ManageSell("USDCADm",lot,TakeProfit_USDCAD,StopLoss_USDCAD,Slippage,MaxSpread_USDCAD,426819,"!xMeter USDvsCAD"); }
   
    if ( EUR_JPY == true && eur >= HighLevel_EURJPY && jpy <= LowLevel_EURJPY && eur > 0 && jpy > 0) { ManageBuy("EURJPYm",lot,TakeProfit_EURJPY,StopLoss_EURJPY,Slippage,MaxSpread_EURJPY,426810,"!xMeter EURvsJPY"); }
    if ( EUR_JPY == true && jpy >= HighLevel_EURJPY && eur <= LowLevel_EURJPY && eur > 0 && jpy > 0) { ManageSell("EURJPYm",lot,TakeProfit_EURJPY,StopLoss_EURJPY,Slippage,MaxSpread_EURJPY,426810,"!xMeter EURvsJPY"); }
   
    if ( EUR_GBP == true && eur >= HighLevel_EURGBP && gbp <= LowLevel_EURGBP && eur > 0 && gbp > 0) { ManageBuy("EURGBPm",lot,TakeProfit_EURGBP,StopLoss_EURGBP,Slippage,MaxSpread_EURGBP,426809,"!xMeter EURvsGBP"); }
    if ( EUR_GBP == true && gbp >= HighLevel_EURGBP && eur <= LowLevel_EURGBP && eur > 0 && gbp > 0) { ManageSell("EURGBPm",lot,TakeProfit_EURGBP,StopLoss_EURGBP,Slippage,MaxSpread_EURGBP,426809,"!xMeter EURvsGBP"); }
   
    if ( EUR_CHF == true && eur >= HighLevel_EURCHF && chf <= LowLevel_EURCHF && eur > 0 && chf > 0) { ManageBuy("EURCHFm",lot,TakeProfit_EURCHF,StopLoss_EURCHF,Slippage,MaxSpread_EURCHF,426808,"!xMeter EURvsCHF"); }
    if ( EUR_CHF == true && chf >= HighLevel_EURCHF && eur <= LowLevel_EURCHF && eur > 0 && chf > 0) { ManageSell("EURCHFm",lot,TakeProfit_EURCHF,StopLoss_EURCHF,Slippage,MaxSpread_EURCHF,426808,"!xMeter EURvsCHF"); }
   
    if ( EUR_AUD == true && eur >= HighLevel_EURAUD && aud <= LowLevel_EURAUD && eur > 0 && aud > 0) { ManageBuy("EURAUDm",lot,TakeProfit_EURAUD,StopLoss_EURAUD,Slippage,MaxSpread_EURAUD,426806,"!xMeter EURvsAUD"); }
    if ( EUR_AUD == true && aud >= HighLevel_EURAUD && eur <= LowLevel_EURAUD && eur > 0 && aud > 0) { ManageSell("EURAUDm",lot,TakeProfit_EURAUD,StopLoss_EURAUD,Slippage,MaxSpread_EURAUD,426806,"!xMeter EURvsAUD"); }
      
    if ( GBP_JPY == true && gbp >= HighLevel_GBPJPY && jpy <= LowLevel_GBPJPY && gbp > 0 && jpy > 0) { ManageBuy("GBPJPYm",lot,TakeProfit_GBPJPY,StopLoss_GBPJPY,Slippage,MaxSpread_GBPJPY,426813,"!xMeter GBPvsJPY"); }
    if ( GBP_JPY == true && jpy >= HighLevel_GBPJPY && gbp <= LowLevel_GBPJPY && gbp > 0 && jpy > 0) { ManageSell("GBPJPYm",lot,TakeProfit_GBPJPY,StopLoss_GBPJPY,Slippage,MaxSpread_GBPJPY,426813,"!xMeter GBPvsJPY"); }
   
    if ( GBP_CHF == true && gbp >= HighLevel_GBPCHF && chf <= LowLevel_GBPCHF && gbp > 0 && chf > 0) { ManageBuy("GBPCHFm",lot,TakeProfit_GBPCHF,StopLoss_GBPCHF,Slippage,MaxSpread_GBPCHF,426812,"!xMeter GBPvsCHF"); }
    if ( GBP_CHF == true && chf >= HighLevel_GBPCHF && gbp <= LowLevel_GBPCHF && gbp > 0 && chf > 0) { ManageSell("GBPCHFm",lot,TakeProfit_GBPCHF,StopLoss_GBPCHF,Slippage,MaxSpread_GBPCHF,426812,"!xMeter GBPvsCHF"); }

  }
  
double GetPoint(string mSymbol)
{
/*
  double myPoint = 0.0001, YenPoint = 0.01;


 string mySymbol;
 
 mySymbol = StringSubstr(mSymbol,0,6);                        // Only look at first 6 characters of pair
 
 if (mySymbol == "USDJPY") return (YenPoint);
 if (mySymbol == "EURJPY") return (YenPoint);
 if (mySymbol == "GBPJPY") return (YenPoint);
*/
 double myPoint = 1;
 return(myPoint);

}

int iLookup(double ratio)                                                   // this function will return a grade value
  {                                                                         // based on its power.
   int    aTable[TABSIZE]  = {0,3,10,25,40,50,60,75,90,97};                 // grade table for currency's power
  // int    aTable[TABSIZE]  = {-50,-47,40,-25,-10,0,10,25,47,50};
   int   index;
   
   if      (ratio <= aTable[0]) index = 0;
   else if (ratio < aTable[1])  index = 0;
   else if (ratio < aTable[2])  index = 1;
   else if (ratio < aTable[3])  index = 2;
   else if (ratio < aTable[4])  index = 3;
   else if (ratio < aTable[5])  index = 4;
   else if (ratio < aTable[6])  index = 5;
   else if (ratio < aTable[7])  index = 6;
   else if (ratio < aTable[8])  index = 7;
   else if (ratio < aTable[9])  index = 8;
   else                         index = 9;
   return(index);                                                           // end of iLookup function
  }

int viLookup(double ratio)                                                   // this function will return a grade value
  {                                                                         // based on its power.
   int    aTable[TABSIZE]  = {0,3,10,25,40,50,60,75,90,97};                 // grade table for currency's power
   //int    aTable[TABSIZE]  = {-50,-47,-40,-25,-10,0,10,25,47,50};
   int   index;
   
   if      (ratio <= aTable[0]) index = 0;
   else if (ratio < aTable[1])  index = 0;
   else if (ratio < aTable[2])  index = 1;
   else if (ratio < aTable[3])  index = 2;
   else if (ratio < aTable[4])  index = 3;
   else if (ratio < aTable[5])  index = 4;
   else if (ratio < aTable[6])  index = 5;
   else if (ratio < aTable[7])  index = 6;
   else if (ratio < aTable[8])  index = 7;
   else if (ratio < aTable[9])  index = 8;
   else                         index = 9;
   return(index);                                                           // end of iLookup function
  }
  
void initGraph()
  {
   ObjectsDeleteAll(0,OBJ_LABEL);

   objectCreate("usd_1",130,43);
   objectCreate("usd_2",130,35);
   objectCreate("usd_3",130,27);
   objectCreate("usd_4",130,19);
   objectCreate("usd_5",130,11);
   objectCreate("usd",132,12,"USD",7,"Arial Narrow",SkyBlue);
   objectCreate("usdp",134,21,DoubleToStr(9,1),8,"Arial Narrow",Silver);
   
   objectCreate("eur_1",110,43);
   objectCreate("eur_2",110,35);
   objectCreate("eur_3",110,27);
   objectCreate("eur_4",110,19);
   objectCreate("eur_5",110,11);
   objectCreate("eur",112,12,"EUR",7,"Arial Narrow",SkyBlue);
   objectCreate("eurp",114,21,DoubleToStr(9,1),8,"Arial Narrow",Silver);
   
   objectCreate("gbp_1",90,43);
   objectCreate("gbp_2",90,35);
   objectCreate("gbp_3",90,27);
   objectCreate("gbp_4",90,19);
   objectCreate("gbp_5",90,11);
   objectCreate("gbp",92,12,"GBP",7,"Arial Narrow",SkyBlue);
   objectCreate("gbpp",94,21,DoubleToStr(9,1),8,"Arial Narrow",Silver);
   
   objectCreate("chf_1",70,43);
   objectCreate("chf_2",70,35);
   objectCreate("chf_3",70,27);
   objectCreate("chf_4",70,19);
   objectCreate("chf_5",70,11);
   objectCreate("chf",72,12,"CHF",7,"Arial Narrow",SkyBlue);
   objectCreate("chfp",74,21,DoubleToStr(9,1),8,"Arial Narrow",Silver);

   objectCreate("cad_1",50,43);
   objectCreate("cad_2",50,35);   
   objectCreate("cad_3",50,27);
   objectCreate("cad_4",50,19);
   objectCreate("cad_5",50,11);
   objectCreate("cad",52,12,"CAD",7,"Arial Narrow",SkyBlue);
   objectCreate("cadp",54,21,DoubleToStr(9,1),8,"Arial Narrow",Silver);
   
   objectCreate("aud_1",30,43);
   objectCreate("aud_2",30,35);
   objectCreate("aud_3",30,27);
   objectCreate("aud_4",30,19);
   objectCreate("aud_5",30,11);
   objectCreate("aud",32,12,"AUD",7,"Arial Narrow",SkyBlue);
   objectCreate("audp",34,21,DoubleToStr(9,1),8,"Arial Narrow",Silver);

   objectCreate("jpy_1",10,43);
   objectCreate("jpy_2",10,35);
   objectCreate("jpy_3",10,27);
   objectCreate("jpy_4",10,19);
   objectCreate("jpy_5",10,11);
   objectCreate("jpy",13,12,"JPY",7,"Arial Narrow",SkyBlue);
   objectCreate("jpyp",14,21,DoubleToStr(9,1),8,"Arial Narrow",Silver);
   
   objectCreate("line",10,6,"-----------------------------------",10,"Arial",DimGray);  
   objectCreate("line1",10,27,"-----------------------------------",10,"Arial",DimGray);  
   objectCreate("line2",10,69,"-----------------------------------",10,"Arial",DimGray);
   objectCreate("sign",11,1," Price Meter System GPL ",8,"Arial Narrow",DimGray);
   WindowRedraw();
  }
//+------------------------------------------------------------------+
void objectCreate(string name,int x,int y,string text="-",int size=42,
                  string font="Arial",color colour=CLR_NONE)
  {
   ObjectCreate(name,OBJ_LABEL,0,0,0);
   ObjectSet(name,OBJPROP_CORNER,3);
   ObjectSet(name,OBJPROP_COLOR,colour);
   ObjectSet(name,OBJPROP_XDISTANCE,x);
   ObjectSet(name,OBJPROP_YDISTANCE,y);
   ObjectSetText(name,text,size,font,colour);
  }

void objectBlank()
  {
   ObjectSet("usd_1",OBJPROP_COLOR,CLR_NONE);
   ObjectSet("usd_2",OBJPROP_COLOR,CLR_NONE);
   ObjectSet("usd_3",OBJPROP_COLOR,CLR_NONE);
   ObjectSet("usd_4",OBJPROP_COLOR,CLR_NONE);
   ObjectSet("usd_5",OBJPROP_COLOR,CLR_NONE);
   ObjectSet("usd",OBJPROP_COLOR,CLR_NONE);
   ObjectSet("usdp",OBJPROP_COLOR,CLR_NONE);

   ObjectSet("eur_1",OBJPROP_COLOR,CLR_NONE);
   ObjectSet("eur_2",OBJPROP_COLOR,CLR_NONE);
   ObjectSet("eur_3",OBJPROP_COLOR,CLR_NONE);
   ObjectSet("eur_4",OBJPROP_COLOR,CLR_NONE);
   ObjectSet("eur_5",OBJPROP_COLOR,CLR_NONE);
   ObjectSet("eur",OBJPROP_COLOR,CLR_NONE);
   ObjectSet("eurp",OBJPROP_COLOR,CLR_NONE);

   ObjectSet("gbp_1",OBJPROP_COLOR,CLR_NONE);
   ObjectSet("gbp_2",OBJPROP_COLOR,CLR_NONE);
   ObjectSet("gbp_3",OBJPROP_COLOR,CLR_NONE);
   ObjectSet("gbp_4",OBJPROP_COLOR,CLR_NONE);
   ObjectSet("gbp_5",OBJPROP_COLOR,CLR_NONE);
   ObjectSet("gbp",OBJPROP_COLOR,CLR_NONE);
   ObjectSet("gbpp",OBJPROP_COLOR,CLR_NONE);

   ObjectSet("chf_1",OBJPROP_COLOR,CLR_NONE);
   ObjectSet("chf_2",OBJPROP_COLOR,CLR_NONE);
   ObjectSet("chf_3",OBJPROP_COLOR,CLR_NONE);
   ObjectSet("chf_4",OBJPROP_COLOR,CLR_NONE);
   ObjectSet("chf_5",OBJPROP_COLOR,CLR_NONE);
   ObjectSet("chf",OBJPROP_COLOR,CLR_NONE);
   ObjectSet("chfp",OBJPROP_COLOR,CLR_NONE);

   ObjectSet("cad_1",OBJPROP_COLOR,CLR_NONE);
   ObjectSet("cad_2",OBJPROP_COLOR,CLR_NONE);
   ObjectSet("cad_3",OBJPROP_COLOR,CLR_NONE);
   ObjectSet("cad_4",OBJPROP_COLOR,CLR_NONE);
   ObjectSet("cad_5",OBJPROP_COLOR,CLR_NONE);
   ObjectSet("cad",OBJPROP_COLOR,CLR_NONE);
   ObjectSet("cadp",OBJPROP_COLOR,CLR_NONE);

   ObjectSet("aud_1",OBJPROP_COLOR,CLR_NONE);
   ObjectSet("aud_2",OBJPROP_COLOR,CLR_NONE);
   ObjectSet("aud_3",OBJPROP_COLOR,CLR_NONE);
   ObjectSet("aud_4",OBJPROP_COLOR,CLR_NONE);
   ObjectSet("aud_5",OBJPROP_COLOR,CLR_NONE);
   ObjectSet("aud",OBJPROP_COLOR,CLR_NONE);
   ObjectSet("audp",OBJPROP_COLOR,CLR_NONE);

   ObjectSet("jpy_1",OBJPROP_COLOR,CLR_NONE);
   ObjectSet("jpy_2",OBJPROP_COLOR,CLR_NONE);
   ObjectSet("jpy_3",OBJPROP_COLOR,CLR_NONE);
   ObjectSet("jpy_4",OBJPROP_COLOR,CLR_NONE);
   ObjectSet("jpy_5",OBJPROP_COLOR,CLR_NONE);
   ObjectSet("jpy",OBJPROP_COLOR,CLR_NONE);
   ObjectSet("jpyp",OBJPROP_COLOR,CLR_NONE);
   
   ObjectSet("line1",OBJPROP_COLOR,CLR_NONE);
   ObjectSet("line2",OBJPROP_COLOR,CLR_NONE); 
  }
  
void paintUSD(double value)
  {
   if (value > 0) ObjectSet("usd_5",OBJPROP_COLOR,Red);
   if (value > 2) ObjectSet("usd_4",OBJPROP_COLOR,Orange);
   if (value > 4) ObjectSet("usd_3",OBJPROP_COLOR,Gold);   
   if (value > 6) ObjectSet("usd_2",OBJPROP_COLOR,YellowGreen);
   if (value > 7) ObjectSet("usd_1",OBJPROP_COLOR,Lime);
   ObjectSet("usd",OBJPROP_COLOR,SkyBlue);
   ObjectSetText("usdp",DoubleToStr(value,1),8,"Arial Narrow",Silver);
  }

void paintEUR(double value)
  {
   if (value > 0) ObjectSet("eur_5",OBJPROP_COLOR,Red);
   if (value > 2) ObjectSet("eur_4",OBJPROP_COLOR,Orange);
   if (value > 4) ObjectSet("eur_3",OBJPROP_COLOR,Gold);   
   if (value > 6) ObjectSet("eur_2",OBJPROP_COLOR,YellowGreen);
   if (value > 7) ObjectSet("eur_1",OBJPROP_COLOR,Lime);
   ObjectSet("eur",OBJPROP_COLOR,SkyBlue);
   ObjectSetText("eurp",DoubleToStr(value,1),8,"Arial Narrow",Silver);
  }

void paintGBP(double value)
  {
   if (value > 0) ObjectSet("gbp_5",OBJPROP_COLOR,Red);
   if (value > 2) ObjectSet("gbp_4",OBJPROP_COLOR,Orange);
   if (value > 4) ObjectSet("gbp_3",OBJPROP_COLOR,Gold);   
   if (value > 6) ObjectSet("gbp_2",OBJPROP_COLOR,YellowGreen);
   if (value > 7) ObjectSet("gbp_1",OBJPROP_COLOR,Lime);
   ObjectSet("gbp",OBJPROP_COLOR,SkyBlue);
   ObjectSetText("gbpp",DoubleToStr(value,1),8,"Arial Narrow",Silver);
  }

void paintCHF(double value)
  {
   if (value > 0) ObjectSet("chf_5",OBJPROP_COLOR,Red);
   if (value > 2) ObjectSet("chf_4",OBJPROP_COLOR,Orange);
   if (value > 4) ObjectSet("chf_3",OBJPROP_COLOR,Gold);   
   if (value > 6) ObjectSet("chf_2",OBJPROP_COLOR,YellowGreen);
   if (value > 7) ObjectSet("chf_1",OBJPROP_COLOR,Lime);
   ObjectSet("chf",OBJPROP_COLOR,SkyBlue);
   ObjectSetText("chfp",DoubleToStr(value,1),8,"Arial Narrow",Silver);
  }

void paintCAD(double value)
  {
   if (value > 0) ObjectSet("cad_5",OBJPROP_COLOR,Red);
   if (value > 2) ObjectSet("cad_4",OBJPROP_COLOR,Orange);
   if (value > 4) ObjectSet("cad_3",OBJPROP_COLOR,Gold);   
   if (value > 6) ObjectSet("cad_2",OBJPROP_COLOR,YellowGreen);
   if (value > 7) ObjectSet("cad_1",OBJPROP_COLOR,Lime);
   ObjectSet("cad",OBJPROP_COLOR,SkyBlue);
   ObjectSetText("cadp",DoubleToStr(value,1),8,"Arial Narrow",Silver);
  }

void paintAUD(double value)
  {
   if (value > 0) ObjectSet("aud_5",OBJPROP_COLOR,Red);
   if (value > 2) ObjectSet("aud_4",OBJPROP_COLOR,Orange);
   if (value > 4) ObjectSet("aud_3",OBJPROP_COLOR,Gold);   
   if (value > 6) ObjectSet("aud_2",OBJPROP_COLOR,YellowGreen);
   if (value > 7) ObjectSet("aud_1",OBJPROP_COLOR,Lime);
   ObjectSet("aud",OBJPROP_COLOR,SkyBlue);
   ObjectSetText("audp",DoubleToStr(value,1),8,"Arial Narrow",Silver);
  }

void paintJPY(double value)
  {
   if (value > 0) ObjectSet("jpy_5",OBJPROP_COLOR,Red);
   if (value > 2) ObjectSet("jpy_4",OBJPROP_COLOR,Orange);
   if (value > 4) ObjectSet("jpy_3",OBJPROP_COLOR,Gold);   
   if (value > 6) ObjectSet("jpy_2",OBJPROP_COLOR,YellowGreen);
   if (value > 7) ObjectSet("jpy_1",OBJPROP_COLOR,Lime);
   ObjectSet("jpy",OBJPROP_COLOR,SkyBlue);
   ObjectSetText("jpyp",DoubleToStr(value,1),8,"Arial Narrow",Silver);
  }
  
void paintLine()
  {
   ObjectSet("line1",OBJPROP_COLOR,DimGray);
   ObjectSet("line2",OBJPROP_COLOR,DimGray);
  }
  
//+------------------------------------------------------------------+

void ManageBuy(string symb,double lt,double TP,double SL,int slp,int spd,int magic,string com)
   {
    double ask   =MarketInfo(symb,MODE_ASK);
    double point =MarketInfo(symb,MODE_POINT);
    double sprd  =MarketInfo(symb,MODE_SPREAD);
    if( sprd <= spd )
    {
     total = OrdersTotal();
     int j, orders;
     for(j=0;j<total;j++)
     {
      OrderSelect(j, SELECT_BY_POS, MODE_TRADES);
      if(OrderMagicNumber() == magic) orders++; //---- an order is opened with
     }                                          //---- same symbol, same magic number
   
     if ( orders < 1 )    //---- we can go trading
     {
      if (TP==0) { tp=0; }
      else { tp=ask+TP*point; }
      if (SL==0) { sl=0; }
      else { sl=ask-SL*point; }
      //Print("ticket=OrderSend(",symb,",",OP_BUY,",",lt,",",ask,",",slp,",",sl,",",tp,",",com,",",magic,",",0,",",Lime);
      ticket=OrderSend(symb,OP_BUY,lt,ask,slp,sl,tp,com,magic,0,Lime);
      if( ticket > 0 )
      {
       if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))
       {
        Print("BUY order opened : ",OrderOpenPrice());
       }
      }
      else
      {
       Print("Error opening BUY order : ",GetLastError());
      }
     }    //---- if ( orders < 1 )
    }    //---- if( sprd <= spd )
   }     //---- void
   
void ManageSell(string symb,double lt,double TP,double SL,int slp,int spd,int magic,string com)
   {
    double bid   =MarketInfo(symb,MODE_BID);
    double point =MarketInfo(symb,MODE_POINT);
    double sprd  =MarketInfo(symb,MODE_SPREAD);
    if( sprd <= spd )
    {
     total = OrdersTotal();
     int j, orders;
     for(j=0;j<total;j++)
     {
      OrderSelect(j, SELECT_BY_POS, MODE_TRADES);
      if(OrderMagicNumber() == magic) orders++; //---- an order is opened with
     }                                          //---- same symbol, same magic number
   
     if ( orders < 1 )    //---- we can go trading
     {
      if (TP==0) { tp=0; }
      else { tp=bid-TP*point; }
      if (SL==0) { sl=0; }
      else { sl=bid+SL*point; }
      //Print("ticket=OrderSend(",symb,",",OP_SELL,",",lt,",",bid,",",slp,",",sl,",",tp,",",com,",",magic,",",0,",",Red);
      ticket=OrderSend(symb,OP_SELL,lt,bid,slp,sl,tp,com,magic,0,Red);
      if( ticket > 0 )
      {
       if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))
       {
        Print("SELL order opened : ",OrderOpenPrice());
       }
      }
      else
      {
       Print("Error opening SELL order : ",GetLastError()); 
      }
     }    //---- if ( orders < 1 )
    }    //---- if( sprd <= spd )
   }     //---- void
  